-- Reload always set to §
SetBinding("","UIRELOAD")

-- Autostart WoWLua -  Loop WoWUnit:Show() until it shows..
-- if not WoWUnit then 
   -- local loop = CreateFrame("Frame") 
   -- loop.ag = loop:CreateAnimationGroup() 
   -- loop.ag.anim = loop.ag:CreateAnimation() 
   -- loop.ag.anim:SetDuration(1) 
   -- loop.ag:SetLooping("REPEAT") 
   -- loop.ag:SetScript("OnLoop", 
      -- function(self) 
         -- if WowLua then 
            -- if not WowLuaFrame:IsShown() then 
               -- SlashCmdList["WOWLUA"]("") 
               -- WowLuaFrameCommandEditBox:SetFocus() 
            -- else 
               -- self:Stop() 
            -- end 
         -- end 
   -- end)
   -- loop:SetScript("OnEvent", 
      -- function(self) 
         -- self.ag:Play() 
   -- end) 
   -- loop:RegisterEvent("PLAYER_LOGIN") 
-- end

DevFramePosition = nil

-- Create a DEV frame
function PAB:DevFrame(DevFramePos)
   
   DevFramePosition = DevFramePos
   local AceGUI = LibStub("AceGUI-3.0")
   
   local DevFrame = AceGUI:Create("Frame")
   
   
   DevFrame:SetTitle("Developer: ActionBars")
   DevFrame:SetCallback("OnClose", function(widget) AceGUI:Release(widget) end)
   DevFrame:SetLayout("Flow")
   DevFrame:SetHeight(390) -- 40px for every new row
   DevFrame:SetWidth(305)
   if DevFramePosition then DevFrame:SetPoint(DevFramePosition) else DevFrame:SetPoint("TOPRIGHT")end
   local sizeEditBox = 110
   
   local WoWluaButton = AceGUI:Create("Button")
   WoWluaButton:SetText("WoW Lua")
   WoWluaButton:SetWidth(220)
   WoWluaButton:SetCallback("OnClick", function() if WowLuaFrame:IsShown() then WowLuaFrame:Hide() else SlashCmdList["WOWLUA"]("") WowLuaFrameCommandEditBox:SetFocus() WowLuaFrame:SetPoint("CENTER") end end)
   DevFrame:AddChild(WoWluaButton)
   
   
   local MmButtonInDevFrame = AceGUI:Create("Button")
   MmButtonInDevFrame:SetText("_")
   MmButtonInDevFrame:SetWidth(50)
   MmButtonInDevFrame:SetCallback("OnClick", 
      function() 
         if DevFrame:IsShown() then
            DevFramePosition = DevFrame:GetPoint()
            DevFrame:Hide()
            if minimizeFrame then 
               minimizeFrame:Show()
            elseif minimizeFrame then minimizeFrame:Show() minimizeFrame:SetPoint(DevFramePosition)
            else
               local minimizeFrame = AceGUI:Create("Frame")
               minimizeFrame:SetLayout("Fill")
               minimizeFrame:SetHeight(100)
               minimizeFrame:SetWidth(100)
               minimizeFrame:SetPoint("TOPRIGHT")
               
               local MmButtonInMmFrame = AceGUI:Create("Button")
               MmButtonInMmFrame:SetText("#")
               MmButtonInMmFrame:SetWidth(50)
               MmButtonInMmFrame:SetCallback("OnClick", 
                  function() 
                     
                     DevFramePosition = minimizeFrame:GetPoint()
                     
                     PAB:DevFrame(DevFramePosition)
                     
                     minimizeFrame:Hide()
                     
                     
                     
               end)
               minimizeFrame:AddChild(MmButtonInMmFrame)
            end
         end
   end)
   DevFrame:AddChild(MmButtonInDevFrame)
   
   
   local CubeButton = AceGUI:Create("Button")
   CubeButton:SetText("Cube")
   CubeButton:SetWidth(220)
   CubeButton:SetCallback("OnClick", function()
      if IGAS.UIParent.Cube_Main then
         IGAS.UIParent.Cube_Main.Visible = not IGAS.UIParent.Cube_Main.Visible
      end
   end)
   DevFrame:AddChild(CubeButton)
   
   local APIInterfaceButton = AceGUI:Create("Button")
   APIInterfaceButton:SetText("API interface")
   APIInterfaceButton:SetWidth(220)
   APIInterfaceButton:SetCallback("OnClick", function() SlashCmdList["APIISLASH"]("") end)
   DevFrame:AddChild(APIInterfaceButton)


   local ReloadButton = AceGUI:Create("Button")
   ReloadButton:SetText("Reload")
   ReloadButton:SetWidth(220)
   ReloadButton:SetCallback("OnClick", function() SlashCmdList["RELOAD"]("") end)
   DevFrame:AddChild(ReloadButton)
   
   
   local TestButton = AceGUI:Create("Button")
   TestButton:SetText("Test")
   TestButton:SetWidth(220)
   TestButton:SetCallback("OnClick", function() wowUnit:StartTests(PAB) end)
   DevFrame:AddChild(TestButton)
   
   
   local GetCursorInfoButton = AceGUI:Create("Button")
   GetCursorInfoButton:SetText("GetCursorInfo()")
   GetCursorInfoButton:SetWidth(220)
   GetCursorInfoButton:SetCallback("OnClick", function() SlashCmdList["DUMP"]("GetCursorInfo()") end)
   DevFrame:AddChild(GetCursorInfoButton)
   
   local GetActionBox = AceGUI:Create("EditBox") GetActionBox:SetWidth(sizeEditBox) GetActionBox:DisableButton(true)
   GetActionBox:SetLabel("ActionInfo()")
   GetActionBox:SetCallback("OnEnterPressed",
      function(widget, event, INPUT) 
         if not INPUT then return nil end
         
         print("GetActionInfo('",INPUT,"')= ", GetActionInfo(INPUT))
         
         GetActionBox:HighlightText() 
         GetActionBox:SetFocus() 
   end)
   DevFrame:AddChild(GetActionBox)
   
   
   
   
   local PABSavedActionBox = AceGUI:Create("EditBox") PABSavedActionBox:SetWidth(sizeEditBox) PABSavedActionBox:DisableButton(true)
   PABSavedActionBox:SetLabel("PAB:SavedAction()")
   PABSavedActionBox:SetCallback("OnEnterPressed",
      function(widget, event, INPUT) 
         if not INPUT then return nil end
		 
         PAB:dump_absPos(INPUT,1) 
         PABSavedActionBox:HighlightText()
         PABSavedActionBox:SetFocus() 
   end)
   DevFrame:AddChild(PABSavedActionBox)
   
   local GetSpellInfoBox = AceGUI:Create("EditBox") GetSpellInfoBox:SetWidth(sizeEditBox) GetSpellInfoBox:DisableButton(true)
   GetSpellInfoBox:SetLabel("SpellInfo()")
   GetSpellInfoBox:SetCallback("OnEnterPressed",
      function(widget, event, INPUT) 
         if not INPUT then return nil end
         
         print("GetSpellInfo('",INPUT,"')= ", GetSpellInfo(INPUT))
         
         GetSpellInfoBox:SetFocus() 
   end)
   DevFrame:AddChild(GetSpellInfoBox)
   
   local FlyoutInfoBox = AceGUI:Create("EditBox") FlyoutInfoBox:SetWidth(sizeEditBox) FlyoutInfoBox:DisableButton(true)
   FlyoutInfoBox:SetLabel("FlyoutInfoInfo() ["..GetNumFlyouts().."]")
   FlyoutInfoBox:SetCallback("OnEnterPressed",
      function(widget, event, INPUT) 
         if not INPUT then return nil end
         
         print("GetFlyoutInfo('",INPUT,"')= ", GetFlyoutInfo(INPUT))
         
         FlyoutInfoBox:HighlightText()
         FlyoutInfoBox:SetFocus() 
   end)
   DevFrame:AddChild(FlyoutInfoBox)
   
   local CompanionInfoBox = AceGUI:Create("EditBox") CompanionInfoBox:SetWidth(sizeEditBox) CompanionInfoBox:DisableButton(true)
   
   CompanionInfoBox:SetLabel("CompanionI() ["..GetNumCompanions("CRITTER").."]")
   CompanionInfoBox:SetCallback("OnEnterPressed",
      function(widget, event, INPUT)
         if not INPUT then return nil end
         
         print("GetCompanionInfo('",INPUT,"')= ", GetCompanionInfo("CRITTER",INPUT))
         
         CompanionInfoBox:HighlightText()
         CompanionInfoBox:SetFocus() 
   end)
   DevFrame:AddChild(CompanionInfoBox)
   
   
   local ItemInfoBox = AceGUI:Create("EditBox") ItemInfoBox:SetWidth(sizeEditBox) ItemInfoBox:DisableButton(true)
   
   ItemInfoBox:SetLabel("ItemInfo()")
   ItemInfoBox:SetCallback("OnEnterPressed",
      function(widget, event, INPUT)
         if not INPUT then return nil end
         
         print("GetItemInfo('",INPUT,"')= ", GetItemInfo(INPUT)) 
         
         ItemInfoBox:HighlightText()
         ItemInfoBox:SetFocus() 
   end)
   DevFrame:AddChild(ItemInfoBox)
   
   local DumpBox = AceGUI:Create("EditBox") DumpBox:SetWidth(sizeEditBox) DumpBox:DisableButton(true)
   
   DumpBox:SetLabel("Dump()")
   DumpBox:SetCallback("OnEnterPressed",
      function(widget, event, INPUT)
         if not INPUT then return nil end
         
         SlashCmdList["DUMP"](INPUT) 
         
         DumpBox:HighlightText()
         DumpBox:SetFocus() 
   end)
   DevFrame:AddChild(DumpBox)
   
   
end

PAB:DevFrame()
